<?php
/*
Plugin Name: Superadmin helper
Plugin URI: http://zaantar.eu/index.php?page=superadmin-helper
Description: Sada utilit pro zjednodušení správy sítě blogů. Superadministrátorský plugin. <strong>Vyvinuto a určeno pro blogosphere.cz</strong>
Version: 1.2
Author: Zaantar
Author URI: http://zaantar.eu
License: GPL2
*/

/*
    Copyright 2010 Zaantar (email: zaantar@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/*****************************************************************************\
		OPTIONS
\*****************************************************************************/

add_action( 'network_admin_menu','suh_network_admin_menu' );

function suh_network_admin_menu() {
	add_submenu_page( 'settings.php', 'Nastavení Superadmin helper', 'Superadmin helper', 'manage_network_options', 
		'suh-options', 'suh_options_page' );
}

function suh_options_page() {
	if( isset($_REQUEST['action']) ) {
        $action = $_REQUEST['action'];
    } else {
        $action = 'default';
    }
    
    switch( $action ) {
    case 'wls-register':
    	$ok1 = wls_register( 'suh-log', 'Záznamy o dění v síti od pluginu Superadmin Helper.' );
    	$ok2 = wls_register( 'suh-mail', 'Seznam e-mailů odeslaných WordPressem.' );
    	$ok = $ok1 && $ok2;
    	if( $ok ) {
    		$info = 'Superadmin Helper byl úspěšně zaregistrován k WLS.';
    		suh_nag( $info );
    		suh_log( $info );
    	} else {
    		$info = 'Při pokusu o registraci Superadmin Helper k WLS došlo k chybě.';
    		suh_nagerr( $info );
    		suh_log( $info, WLS_ERROR );
    	}
    	suh_options_page_default();
    	break;
    case 'wls-unregister':
    	$ok1 = wls_unregister( 'suh-log' );
    	$ok2 = wls_unregister( 'suh-mail' );
    	$ok = $ok1 && $ok2;
    	if( $ok ) {
    		$info = 'Superadmin Helper byl úspěšně odregistrován z WLS, systémové logy byly smazány.';
    		suh_nag( $info );
    		suh_log( $info );
    	} else {
    		$info = 'Při pokusu o odregistraci Superadmin Helper z WLS došlo k chybě.';
    		suh_nagerr( $info );
    		suh_log( $info, WLS_ERROR );
    	}
    	suh_options_page_default();
    	break;
    default:
    	suh_options_page_default();
    	break;
    }
}


function suh_options_page_default() {
	?>
	<div id="wrap">
		<h2>Nastavení Superadmin Helper</h2>
		<?php
			if( defined( 'WLS' ) ) {
				?>			 
				<h3>Registrace do systémového logu WLS</h3>
		    	<p>Byl detekován nainstalovaný plugin Wordpress Logging Service.</p>
	    		<?php
	    			if( !wls_is_registered( 'suh-log' ) or !wls_is_registered( 'suh-mail' ) ) {
	    				?>
						<form method="post" action="settings.php?page=suh-options">
							<input type="hidden" name="action" value="wls-register" />
							<p class="submit">
								<input type="submit" value="Registrovat Superadmin Helper do WLS" />    
							</p> 
						</form>
						<?php
					} else {
						?>
						<form method="post" action="settings.php?page=suh-options">
							<input type="hidden" name="action" value="wls-unregister" />
							<p class="submit">
								<input type="submit" style="color:red;" value="Odregistrovat Superadmin Helper z WLS a nevratně smazat všechny logy" />    
							</p> 
						</form>
						<?php
					}
				?>
				<?php
        	} else {
        		?>
        		<p>Nebyl nalezen plugin Wordpress Logging Service - není co nastavovat.</p>
        		<?php
        	}
        ?>	
	</div>
	<?php
}

/* ************************************************************************* *\
		LOGGING INTERFACE
\* ************************************************************************* */


function suh_nag( $message ) {
	echo( '<div id="message" class="updated"><p>'.$message.'</p></div>' );
}

function suh_nagerr( $message ) {
	echo( '<div id="message" class="error"><p>'.$message.'</p></div>' );
}

function suh_log( $message, $category = 1 ) {
	if( !defined( 'WLS' ) or !wls_is_registered( 'suh-log' ) ) {
		$filename = dirname(__FILE__).'/log.txt';
		$file = fopen( $filename, 'ä́' );
		fwrite( $file, $message );
		fclose( $file );
	} else {
		wls_simple_log( 'suh-log', $message, $category );
	}
}


/* ************************************************************************* *\
		MULTISITE EVENT LOGGING
\* ************************************************************************* */


// user profile update 

add_action('profile_update','suh_user_profile_update');

function suh_user_profile_update( $user_id ) {
	$userdata = get_userdata( $user_id );
	$subject = '['.get_site_option( 'site_name' ).'] Aktualizace uživatelského profilu';
	$message = 'Uživatelský profil byl aktualizován: '.print_r( $userdata, true );
	suh_log( $message );
}


// sending e-mails

add_filter('wp_mail', 'suh_log_email' );

function suh_log_email( $mail_info ) {
	wls_simple_log( 'suh-mail', 'Sending an e-mail with subject "'.$mail_info['subject'].'"'."\n".'To: '.$mail_info['to']."\n".' Headers: '.$mail_info['headers']."\n".'Message: '.$mail_info['message']."\n".'Attachments: '.$mail_info['attachments'], 0 );
	return $mail_info;
}


// logging in

add_action( 'wp_login', 'suh_log_login' );

function suh_log_login( $username ) {
	suh_log( 'User '.$username.' logging in.' );
}


// resetting password

add_action( 'lostpassword_post', 'suh_log_lostpassword_post');

function suh_log_lostpassword_post() {
	suh_log( 'A password reset was requested.' );
	return;
}

add_action( 'password_reset', 'suh_log_password_reset');

function suh_log_password_reset( $user ) {
	suh_log( 'User '.$user->user_login.' has reset it\'s password.', 2 );
}


// deleting an user

add_action( 'delete_user', 'suh_log_delete_user');

function suh_log_delete_user( $user_id ) {
	suh_log( 'User ID='.$user_id.' was deleted.', 2 );
}


// uploading a file

add_action( 'add_attachment', 'suh_log_add_attachment' );

function suh_log_add_attachment( $id ) {
	$file = get_attached_file( $id );
	suh_log( 'File uploaded: "' . $file . '"' );
}


// user logout

add_action( 'wp_logout', 'suh_log_wp_logout' );

function suh_log_wp_logout( $user_login ) {
	suh_log( 'User '.$user_login.' has logged out.' );
}


// user registered

add_action( 'user_register', 'suh_log_user_register');

function suh_log_user_register( $user_id ) {
	$userdata = get_userdata( $user_id );
	suh_log( 'User '.$userdata->user_login.' registered.', 2 );
}


// theme switch

add_action( 'switch_theme', 'suh_log_switch_theme' );

function suh_log_switch_theme( $theme ) {
	suh_log( 'Theme switched to '.$theme.'.', 2 );
}


// monitor plugins

add_action( 'load-plugins.php', 'suh_monitor_plugins' );
add_action( 'update.php', 'suh_monitor_plugins' );

function suh_monitor_plugins() {
	$current = get_plugins();

	foreach($current as $plugin_file => $plugin_data) {
		if ($plugin_file == plugin_basename(__FILE__)) continue;
		add_action('deactivate_' . $plugin_file, 'suh_log_deactivate_plugin');
		add_action('activate_' . $plugin_file, 'suh_log_activate_plugin');
	}
}


function suh_log_activate_plugin() {
	$plugin = trim($_GET['plugin']);
	suh_log( 'Plugin activated: "'.$plugin.'"', 2 );
}

function suh_log_deactivate_plugin() {
	if (isset($_GET['plugin'])) {
		$plugin = trim($_GET['plugin']);
		suh_log( 'Plugin deactivated: "'.$plugin.'"', 2);
	}
	elseif ($_GET['action'] == 'deactivate-all') {
		//are we Deactivating All?
		suh_log_('All plugins have been deactivated.', 3);
	}
}


// login errors

add_action('wp_login_failed', 'suh_log_login_error' );

function suh_log_login_error( $username ) {
	$user = get_userdatabylogin($username);
	if ( !$user || ($user->user_login != $username) ) {
		suh_log( 'Login failed: unknown user "' . $username . '".', 4 );
	} else {
		suh_log('Login failed: incorrect oassword for '.$username.'.', 4 );
	}
}


/* ************************************************************************* *\
    	SUPERADMIN CAN CHANGE USER'S PRIMARY BLOG
\* ************************************************************************* */


add_action( 'show_user_profile','suh_pb_show_user_profile' );
add_action( 'edit_user_profile','suh_pb_show_user_profile' );
add_action( 'personal_options_update', 'suh_pb_edit_user_profile' );
add_action( 'edit_user_profile_update', 'suh_pb_edit_user_profile' );

function suh_pb_show_user_profile( $user ) {
	if( !is_super_admin() ) {
		return;
	}
	?>
	<h3>Superadmin mód</h3>
	<p>
		Při změnách těchto polí buďte velmi opatrní! Můžete tím toho nejspíš hodně zkazit.
	</p>
	<table class="form-table">
		<tr>
		    <th><label for="primary_blog">Primární blog</label></th>
		    <td>
		        <input type="text" name="primary_blog" id="primary_blog" value="<?php echo( get_user_meta( $user->ID, 'primary_blog', true ) ); ?>" class="regular-text">
		    </td>
		</tr>
	</table>
	<?php
}	


function suh_pb_edit_user_profile( $user_id ) {
	if( !is_super_admin() ) {
		return;
	}
	$pb = $_POST['primary_blog'];
	//echo 'uid:'.$user_id;
	update_user_meta( $user_id, 'primary_blog', $pb );
}


?>
